#include <stdio.h>
#include <string.h>
#include <ctype.h>
#define MAXLIGNES 5
#define MAXMOTS 50
#define MOTLEN 25

typedef char ligne[100];
typedef char mot[MOTLEN];

int lire_texte(ligne[], const int maxl);
char * prends_mot_suivant(char *source, mot mots);
int separer_mots(ligne texte[], mot dict[], const int nl, const int maxmot);
void aff_mots(char *dict[], const int n);
void trie_mots(char *dict[], const int n);

void main (void){
ligne tex[MAXLIGNES];
mot dict[MAXMOTS];
char *d1[MAXMOTS];

int nl, nm,i;
 for (i=0; i<MAXMOTS;i++) d1[i]=dict[i];
 nl= lire_texte(tex,MAXLIGNES);
 nm = separer_mots(tex,dict,nl,MAXMOTS);
 aff_mots(d1,nm);
 trie_mots(d1,nm);
 aff_mots(d1,nm);
}

int lire_texte(ligne texte[], const int maxl){
  int i;
  ligne l;
  for (i=0; i < maxl && gets(l) !=NULL && strlen(l)>0; i++){
	  strcpy(texte[i],l);
  }
  return i;
}

char* prends_mot_suivant(char *source, mot mots){
	 char *p = mots;
	 *p = '\0';
	 // sauter les caract'eres qui ne sont pas dans un mot
	 while ( *source != '\0' && ! isalpha(*source)) source++;
	 if ( *source == '\0') return NULL;
	 // separer le mot
	 while (isalpha(*source) || *source =='-') *p++ = *source++;
	 *p = '\0';
	 return source;
}

int separer_mots(ligne texte[], mot dict[], const int nl, const int maxmot){
  char *curligne;
  int l, n=0;
  for (l=0; l<nl; l++) {
	 curligne = texte[l];
	 while (n<maxmot &&  curligne !=NULL && *curligne != '\0') {
		 if ((curligne=prends_mot_suivant( curligne,dict[n])) != NULL) n++;
	 }
  }
  return n;
}

void aff_mots(char *dict[], const int n){
  int i;
  for (i=0;i<n;i++) puts(dict[i]);
}
void trie_mots(char *dict[], const int n){
  // trie les mots a la boule
	char *t;
	int i,exch;
	do{
	  exch = 0;
	  for (i=1;i<n;i++) {
		  if (strcmp(dict[i-1],dict[i])>0){
				exch =1;
				t =dict[i-1];
				dict[i-1]=dict[i];
				dict[i]=t;
		  }
		}
	}while (exch);
}
